/*
* Creaci dels triggers de la BD.
* S'ha d'executar connectat com a monitor/monitor1606
*/

spool 05_CreacioTriggers.log;

--------------------------------------------------------
--  DDL  for Triggers Before Insert
--------------------------------------------------------

-- Taula CLIENT.
CREATE OR REPLACE TRIGGER TR_BI_CLIENT 
	BEFORE INSERT ON CLIENT FOR EACH ROW 
	BEGIN   
		SELECT  CLIENT_SEQ.NEXTVAL INTO :NEW.ID_CLIENT FROM DUAL; 
	END;
/

-- Taula SERVEI_WEB.
CREATE OR REPLACE TRIGGER TR_BI_SERVEI_WEB
	BEFORE INSERT ON SERVEI_WEB FOR EACH ROW 
	BEGIN   
		SELECT  SERVEI_WEB_SEQ.NEXTVAL INTO :NEW.ID_SERVEI_WEB FROM DUAL; 
	END;
/

-- Taula HIST_ESTAT_SERVEI_WEB.
CREATE OR REPLACE TRIGGER TR_BI_HIST_ESTAT_SERVEI_WEB
	BEFORE INSERT ON HIST_ESTAT_SERVEI_WEB FOR EACH ROW 
	BEGIN   
		SELECT  HIST_ESTAT_SERVEI_WEB_SEQ.NEXTVAL INTO :NEW.ID_HIST_ESTAT_SERVEI_WEB FROM DUAL; 
	END;
/

-- Taula REGLA.
CREATE OR REPLACE TRIGGER TR_BI_REGLA
	BEFORE INSERT ON REGLA FOR EACH ROW 
	BEGIN   
		SELECT  REGLA_SEQ.NEXTVAL INTO :NEW.ID_REGLA FROM DUAL; 
	END;
/

-- Taula HIST_ESTAT_REGLA.
CREATE OR REPLACE TRIGGER TR_BI_HIST_ESTAT_REGLA
	BEFORE INSERT ON HIST_ESTAT_REGLA FOR EACH ROW 
	BEGIN   
		SELECT  HIST_ESTAT_REGLA_SEQ.NEXTVAL INTO :NEW.ID_HIST_ESTAT_REGLA FROM DUAL; 
	END;
/

-- Taula PAS.
CREATE OR REPLACE TRIGGER TR_BI_PAS
	BEFORE INSERT ON PAS FOR EACH ROW 
	BEGIN   
		SELECT  PAS_SEQ.NEXTVAL INTO :NEW.ID_PAS FROM DUAL; 
	END;
/

-- Taula HIST_ESTAT_PAS.
CREATE OR REPLACE TRIGGER TR_BI_HIST_ESTAT_PAS
	BEFORE INSERT ON HIST_ESTAT_PAS FOR EACH ROW 
	BEGIN   
		SELECT  HIST_ESTAT_PAS_SEQ.NEXTVAL INTO :NEW.ID_HIST_ESTAT_PAS FROM DUAL; 
	END;
/
  
-- Taula REGISTRE.
CREATE OR REPLACE TRIGGER TR_BI_REGISTRE
	BEFORE INSERT ON REGISTRE FOR EACH ROW 
	BEGIN   
		SELECT  REGISTRE_SEQ.NEXTVAL INTO :NEW.ID_REGISTRE FROM DUAL; 
	END;
/

-- Taula LINIA_REGISTRE.
CREATE OR REPLACE TRIGGER TR_BI_LINIA_REGISTRE
	BEFORE INSERT ON LINIA_REGISTRE FOR EACH ROW 
	BEGIN   
		SELECT  LINIA_REGISTRE_SEQ.NEXTVAL INTO :NEW.ID_LINIA_REGISTRE FROM DUAL; 
	END;
/

-- Taula DISPONIBILITAT_MES.
CREATE OR REPLACE TRIGGER TR_BI_DISPONIBILITAT_MES
	BEFORE INSERT ON DISPONIBILITAT_MES FOR EACH ROW 
	BEGIN   
		SELECT  DISPONIBILITAT_MES_SEQ.NEXTVAL INTO :NEW.ID_DISPONIBILITAT_MES FROM DUAL; 
	END;
/

-- Taula DISPONIBILITAT_DIA.
CREATE OR REPLACE TRIGGER TR_BI_DISPONIBILITAT_DIA
	BEFORE INSERT ON DISPONIBILITAT_DIA FOR EACH ROW 
	BEGIN   
		SELECT  DISPONIBILITAT_DIA_SEQ.NEXTVAL INTO :NEW.ID_DISPONIBILITAT_DIA FROM DUAL; 
	END;
/

-- Taula DW_DISP_SERVEI_TRAM.
CREATE OR REPLACE TRIGGER TR_BI_DW_DISP_SERVEI_TRAM
	BEFORE INSERT ON DW_DISP_SERVEI_TRAM FOR EACH ROW 
	BEGIN   
		SELECT  DW_DISP_SERVEI_TRAM_SEQ.NEXTVAL INTO :NEW.ID_DW_DISP_SERVEI_TRAM FROM DUAL; 
	END;
/

-- Taula DW_RESULTAT_DISP.
CREATE OR REPLACE TRIGGER TR_BI_DW_RESULTAT_DISP
	BEFORE INSERT ON DW_RESULTAT_DISP FOR EACH ROW 
	BEGIN   
		SELECT  DW_RESULTAT_DISP_SEQ.NEXTVAL INTO :NEW.ID_DW_RESULTAT_DISP FROM DUAL; 
	END;
/

-- Taula DW_DIA_MENYS_DISP.
CREATE OR REPLACE TRIGGER TR_BI_DW_DIA_MENYS_DISP
	BEFORE INSERT ON DW_DIA_MENYS_DISP FOR EACH ROW 
	BEGIN   
		SELECT  DW_DIA_MENYS_DISP_SEQ.NEXTVAL INTO :NEW.ID_DW_DIA_MENYS_DISP FROM DUAL; 
	END;
/

-- Taula DW_CLIENT_MENYS_DISP.
CREATE OR REPLACE TRIGGER TR_BI_DW_CLIENT_MENYS_DISP
	BEFORE INSERT ON DW_CLIENT_MENYS_DISP FOR EACH ROW 
	BEGIN   
		SELECT  DW_CLIENT_MENYS_DISP_SEQ.NEXTVAL INTO :NEW.ID_DW_CLIENT_MENYS_DISP FROM DUAL; 
	END;
/

-- Taula DW_REGLA_MES_TEMPS.
CREATE OR REPLACE TRIGGER TR_BI_DW_REGLA_MES_TEMPS
	BEFORE INSERT ON DW_REGLA_MES_TEMPS FOR EACH ROW 
	BEGIN   
		SELECT  DW_REGLA_MES_TEMPS_SEQ.NEXTVAL INTO :NEW.ID_DW_REGLA_MES_TEMPS FROM DUAL; 
	END;
/

-- Taula LOG.
CREATE OR REPLACE TRIGGER TR_BI_LOG
	BEFORE INSERT ON LOG FOR EACH ROW 
	BEGIN   
		SELECT  LOG_SEQ.NEXTVAL INTO :NEW.ID_LOG FROM DUAL; 
	END;
/

--------------------------------------------------------
--  DDL for Trigger TR_AU_PAS
--------------------------------------------------------

create or replace TRIGGER TR_AU_PAS
AFTER UPDATE ON PAS FOR EACH ROW

DECLARE

BEGIN

  IF (:NEW.ESTAT != :OLD.ESTAT) THEN
      INSERT INTO HIST_ESTAT_PAS (PAS, DATA_INICI, DATA_FI, ESTAT)
         VALUES(:OLD.ID_PAS, :OLD.DATA_ESTAT, :NEW.DATA_ESTAT, :OLD.ESTAT);

  END IF;       
END TR_AU_PAS;
/

--------------------------------------------------------
--  DDL for Trigger TR_AU_REGISTRE
--------------------------------------------------------

create or replace TRIGGER TR_AU_REGISTRE 
AFTER UPDATE ON REGISTRE FOR EACH ROW

DECLARE

	LL_ANY						    NUMBER;
	LL_MES						    NUMBER;
	LL_COUNT					    NUMBER := 0;

BEGIN

  IF (:OLD.IND_DISPONIBLE = 'E') AND (:NEW.IND_DISPONIBLE <> 'E') THEN
  
  		LL_ANY := EXTRACT(YEAR FROM :NEW.DATA_INICI);
  		LL_MES := EXTRACT(MONTH FROM :NEW.DATA_INICI);
  		
  		IF :NEW.IND_DISPONIBLE = 'S'	THEN
          SELECT COUNT(*)
          INTO	LL_COUNT
          FROM	DW_RESULTAT_DISP
          WHERE	ANYO				    = LL_ANY
          AND		MES					    = LL_MES
          AND		IND_DISPONIBLE	= :NEW.IND_DISPONIBLE
          AND		CODI_ERROR			IS NULL;
          
          IF (LL_COUNT = 1) THEN
          
            UPDATE	DW_RESULTAT_DISP SET
                    NOMBRE_REGISTRES = NOMBRE_REGISTRES + 1
              WHERE	ANYO				    = LL_ANY
              AND		MES					    = LL_MES
              AND		IND_DISPONIBLE	= :NEW.IND_DISPONIBLE
              AND		CODI_ERROR			IS NULL;
          
          ELSE
            
            INSERT INTO DW_RESULTAT_DISP (ANYO, MES, DATA_CALCUL, IND_DISPONIBLE, 
                        CODI_ERROR, NOMBRE_REGISTRES)
            VALUES(LL_ANY, LL_MES, SYSDATE, :NEW.IND_DISPONIBLE, NULL, 1);
          END IF;          

  		ELSE
          SELECT COUNT(*)
          INTO	LL_COUNT
          FROM	DW_RESULTAT_DISP
          WHERE	ANYO				    = LL_ANY
          AND		MES					    = LL_MES
          AND		IND_DISPONIBLE	= :NEW.IND_DISPONIBLE
          AND		CODI_ERROR			= :NEW.CODI_ERROR;
          
          IF (LL_COUNT = 1) THEN
          
            UPDATE	DW_RESULTAT_DISP SET
                    NOMBRE_REGISTRES = NOMBRE_REGISTRES + 1
              WHERE	ANYO				    = LL_ANY
              AND		MES					    = LL_MES
              AND		IND_DISPONIBLE	= :NEW.IND_DISPONIBLE
              AND		CODI_ERROR			= :NEW.CODI_ERROR;
          
          ELSE
            
            INSERT INTO DW_RESULTAT_DISP (ANYO, MES, DATA_CALCUL, IND_DISPONIBLE, 
                        CODI_ERROR, NOMBRE_REGISTRES)
            VALUES(LL_ANY, LL_MES, SYSDATE, :NEW.IND_DISPONIBLE, :NEW.CODI_ERROR, 1);
          END IF;           
  		END IF;
  END IF;       
END TR_AU_SERVEI_WEB;
/

--------------------------------------------------------
--  DDL for Trigger TR_AU_REGLA
--------------------------------------------------------

create or replace TRIGGER TR_AU_REGLA
AFTER UPDATE ON REGLA FOR EACH ROW

DECLARE

BEGIN

  IF (:NEW.ESTAT != :OLD.ESTAT) THEN
      INSERT INTO HIST_ESTAT_REGLA (REGLA, DATA_INICI, DATA_FI, ESTAT)
         VALUES(:OLD.ID_REGLA, :OLD.DATA_ESTAT, :NEW.DATA_ESTAT, :OLD.ESTAT);

  END IF;       
END TR_AU_REGLA;
/

--------------------------------------------------------
--  DDL for Trigger TR_AU_SERVEI_WEB
--------------------------------------------------------

create or replace TRIGGER TR_AU_SERVEI_WEB
AFTER UPDATE ON SERVEI_WEB FOR EACH ROW

DECLARE

BEGIN

  IF (:NEW.ESTAT != :OLD.ESTAT) THEN
      INSERT INTO HIST_ESTAT_SERVEI_WEB (SERVEI_WEB, DATA_INICI, DATA_FI, ESTAT)
         VALUES(:OLD.ID_SERVEI_WEB, :OLD.DATA_ESTAT, :NEW.DATA_ESTAT, :OLD.ESTAT);

  END IF;       
END TR_AU_SERVEI_WEB;
/

spool off;