/*
* Creaci de procediments emmagatzemats.
* S'ha d'executar connectat com a monitor/monitor1606
*/

spool 07_CreacioProcediments.log;

--------------------------------------------------------
--  DDL for Procedure SP_ALTA_LOG
--------------------------------------------------------

  CREATE OR REPLACE PROCEDURE SP_ALTA_LOG (P_DATA_HORA       IN DATE,
																			   P_NOM_PROCEDIMENT IN VARCHAR2,
																			   P_PARAM_ENTRADA   IN VARCHAR2,
																			   P_PARAM_SORTIDA   IN VARCHAR2)
IS

V_PARAM_ENTRADA  	VARCHAR2(400);
RSP  							VARCHAR2(250);
V_ERR_MSG  				VARCHAR2(200);
V_CAMP_NULL				VARCHAR2(20);
EXC_CAMP_NULL			EXCEPTION;

PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN

   V_PARAM_ENTRADA:= 'P_DATA_HORA: '||P_DATA_HORA||
                     ', P_NOM_PROCEDIMENT: '||P_NOM_PROCEDIMENT||
                     ', P_PARAM_ENTRADA: '||P_PARAM_ENTRADA||
                     ', P_PARAM_SORTIDA: '||P_PARAM_SORTIDA;

  --Verifica que els camps obligatoris no siguin nuls
   IF (P_DATA_HORA IS NULL) THEN 
     V_CAMP_NULL := 'DATA_HORA';
     RAISE EXC_CAMP_NULL;
   END IF;
   IF (P_NOM_PROCEDIMENT IS NULL) THEN 
     V_CAMP_NULL := 'NOM_PROCEDIMENT';     
     RAISE EXC_CAMP_NULL;
   END IF;
   /*
   IF (P_PARAM_ENTRADA IS NULL) THEN 
     V_CAMP_NULL 'PARAM_ENTRADA';
     RAISE EXC_CAMP_NULL     
   END IF;
   IF (P_PARAM_SORTIDA IS NULL) THEN 
     V_CAMP_NULL 'PARAM_SORTIDA';
     RAISE EXC_CAMP_NULL     
   END IF;
 	*/

  -- Inserta un nou registre a la taula LOG
   INSERT INTO LOG (DATA_HORA, NOM_PROCEDIMENT, PARAM_ENTRADA, PARAM_SORTIDA)
   VALUES (P_DATA_HORA, P_NOM_PROCEDIMENT, P_PARAM_ENTRADA, P_PARAM_SORTIDA);
   
  -- Finalitza amb xit. Fa commit en una transacci autnoma.
   RSP:= 'OK';
   COMMIT;
   
EXCEPTION
   WHEN EXC_CAMP_NULL THEN
        RSP:= 'ERROR LOG: El camp ' || V_CAMP_NULL || ' no pot ser nul'; 
        
        INSERT INTO LOG (DATA_HORA, NOM_PROCEDIMENT, PARAM_ENTRADA, PARAM_SORTIDA)
        VALUES (TO_CHAR(SYSDATE,'DD/MM/YYYY HH24:MI:SS'), 'SP_ALTA_LOG', P_PARAM_ENTRADA, 'RSP: '||RSP);
   			COMMIT;

   WHEN OTHERS THEN
        ROLLBACK;
        V_ERR_MSG := SUBSTR (SQLERRM, 1, 200);
        RSP:=    'ERROR LOG: ' || V_ERR_MSG;
        
        INSERT INTO LOG (DATA_HORA, NOM_PROCEDIMENT, PARAM_ENTRADA, PARAM_SORTIDA)
        VALUES (TO_CHAR(SYSDATE,'DD/MM/YYYY HH24:MI:SS'), P_NOM_PROCEDIMENT, P_PARAM_ENTRADA, 'RSP: '||RSP);
   			COMMIT;

END SP_ALTA_LOG;

/
spool off;