/*
* Proves dels procediments de consulta del modul de Data Warehouse.
* S'ha d'executar connectat com a monitor/monitor1606
*/

SET SERVEROUTPUT ON;
spool 120_ProvesConsultesDW.log;

set echo on

/*****************************************************************************************
 																PROVES CONSULTES DATA WAREHOUSE         
*****************************************************************************************/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5a] 
-- Consulta que mostra per pantalla el nombre de registres de monitoritzacio que han donat 
-- com a resultat 'disponibilitat del servei'.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 9 REGISTRES');  
   PKG_CONSULTES_DW.SP_DW_DISP_SERVEI(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
      
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'DISPONIBILITAT DEL SERVEI'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT DISPONIBILITAT DEL SERVEI:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('03/05/2016 00:00:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('03/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), 20, 'S', NULL, RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);       

   -- DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 10 REGISTRES');  
   PKG_CONSULTES_DW.SP_DW_DISP_SERVEI(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);   
END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5b] 
-- Consulta que mostra per pantalla el nombre de registres de monitoritzacio que han donat 
-- com a resultat 'el servei web no respn'.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 0 REGISTRES');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_NO_RESP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
      
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'EL SERVEI WEB NO RESPN'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('03/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('03/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);       

   -- DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 1 REGISTRE');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_NO_RESP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);   
END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5c] 
-- Consulta que mostra per pantalla el nombre de registres de monitoritzacio que han donat 
-- com a resultat 'la resposta del 'servei web no cont la cadena esperada'.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 0 REGISTRES');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_RESP_KO(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
      
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'SERVEI WEB NO CONT LA CADENA ESPERADA'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT SERVEI WEB NO CONT LA CADENA ESPERADA:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('03/05/2016 00:02:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('03/05/2016 00:02:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '002', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);       

   -- DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_RESULTAT_DISP DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 1 REGISTRE');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_RESP_KO(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);   
END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5d] 
-- Consulta que mostra per pantalla el nombre de serveis web que han tingut una disponibilitat 
-- entre el 95% i el 100%, i el nombre de la resta que han estat entre 0% i 95%.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_DISP_SERVEI_TRAM ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_DISP_SERVEI_TRAM ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: ENTRE EL 0% I EL 95%: 1, ENTRE EL 95% I EL 100%: 8');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_TRAM_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'EL SERVEI WEB NO RESPN'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(8, 8, TO_DATE('03/05/2016 00:03:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('03/05/2016 00:03:31', 'DD/MM/YYYY HH24:MI:SS'), 16, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
    
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'SERVEI WEB NO CONT LA CADENA ESPERADA'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT SERVEI WEB NO CONT LA CADENA ESPERADA:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(8, 8, TO_DATE('03/05/2016 00:04:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('03/05/2016 00:04:31', 'DD/MM/YYYY HH24:MI:SS'), 16, 'N', '002', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);       

   -- DADES DE LA TAULA DW_DISP_SERVEI_TRAM DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_DISP_SERVEI_TRAM DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: ENTRE EL 0% I EL 95%: 2, ENTRE EL 95% I EL 100%: 7');  
   PKG_CONSULTES_DW.SP_DW_SERVEI_TRAM_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5e] 
-- Consulta que mostra per pantalla el dia del mes on menys disponibilitat de serveis hi ha 
-- hagut en global.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_DIA_MENYS_DISP ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_DIA_MENYS_DISP ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: DIA 3, AMB UNA DISPONIBILITAT DEL 20%');  
   PKG_CONSULTES_DW.SP_DW_DIA_MENYS_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'EL SERVEI WEB NO RESPN',
   -- QUE FA QUE EL DIA AMB MENYS DISPONIBILITAT SIGUI EL 04/05/2016.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(8, 8, TO_DATE('04/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
  --MODIFICACIO CORRECTA D'UN REGISTRE (FINALITZACIO DE L'ALTA).
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('04/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 16, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
    
   -- DADES DE LA TAULA DW_DIA_MENYS_DISP DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_DIA_MENYS_DISP DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: DIA 4, AMB UNA DISPONIBILITAT DEL 0%');  
   PKG_CONSULTES_DW.SP_DW_DIA_MENYS_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5f] 
-- Consulta que mostra per pantalla el client amb els serveis web que han tingut menys  
-- disponibilitat durant el mes.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_CLIENT_MENYS_DISP ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_CLIENT_MENYS_DISP ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: EL CLIENT ID 4, AMB UNA DISPONIBILITAT DEL 40%');  
   PKG_CONSULTES_DW.SP_DW_CLIENT_MENYS_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   -- ALTA DE NOUS REGISTRES DE MONITORITZACIO, QUE DONI COM A RESULTAT 'EL SERVEI WEB NO RESPN',
   -- QUE FA QUE EL CLIENT AMB MENYS DISPONIBILITAT SIGUI EL 5.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('05/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('05/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('06/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('06/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('07/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('07/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT EL SERVEI WEB NO RESPN:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('08/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('08/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'N', '001', RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
    
   -- DADES DE LA TAULA DW_CLIENT_MENYS_DISP DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_CLIENT_MENYS_DISP DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: EL CLIENT ID 5, AMB UNA DISPONIBILITAT DEL 33,333%');  
   PKG_CONSULTES_DW.SP_DW_CLIENT_MENYS_DISP(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R5g] 
-- Consulta que mostra per pantalla la regla de monitoritzaci que ms temps triga, de mitja, 
-- en executar-se, incloent tots els seus passos.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY 					NUMBER;
  P_MES 					NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 						VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   -- DADES DE LA TAULA DW_REGLA_MES_TEMPS ABANS DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_REGLA_MES_TEMPS ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: REGLA 10, AMB UN TEMPS DE 45.000 MILISEGONS');  
   PKG_CONSULTES_DW.SP_DW_REGLA_MES_TEMPS(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   -- ALTA DE NOUS REGISTRES DE MONITORITZACIO, QUE DONI COM A RESULTAT 'DISPONIBILITAT DEL SERVEI',
   -- QUE FA QUE LA REGLA QUE MES TRIGA EN EXECUTAR-SE SIGUI LA 7.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB RESULTAT DISPONIBILITAT DEL SERVEI:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(7, 7, TO_DATE('05/05/2016 00:01:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('05/05/2016 00:02:01', 'DD/MM/YYYY HH24:MI:SS'), 14, 'S', NULL, RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);  
 
   -- DADES DE LA TAULA DW_REGLA_MES_TEMPS DESPRES DE REALITZAR MODIFICACIONS.
   DBMS_OUTPUT.PUT_LINE('DADES DE LA TAULA DW_REGLA_MES_TEMPS DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: REGLES 7 I 10, AMB UN TEMPS DE 45.000 MILISEGONS');  
   PKG_CONSULTES_DW.SP_DW_REGLA_MES_TEMPS(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

END;
/


spool off;



