/*
* Proves dels procediments de consulta.
* S'ha d'executar connectat com a monitor/monitor1606
*/

SET SERVEROUTPUT ON;
spool 130_ProvesConsultes.log;

set echo on

/*****************************************************************************************
 																PROVES CONSULTES DINAMIQUES         
*****************************************************************************************/

--------------------------------------------------------------------------------------------
-- ID requisit: [R4b] 
-- Consulta que mostra per pantalla el llistat de serveis web que tinguin registres de 
-- monitoritzaci en el quals sha detectat no disponibilitat del servei, agrupats per dia.
--------------------------------------------------------------------------------------------

DECLARE
  P_ANY           NUMBER;
  P_MES           NUMBER;
  V_ID_REGISTRE  	NUMBER;
  RSP 	          VARCHAR2(2000);
BEGIN

  P_ANY := 2016;
  P_MES := 5;
  
   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE SERVEIS WEB AMB REGISTRES DE NO DISPONIBILITAT, ABANS DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 5 REGISTRES PER LA REGLA 10 (TEMPS ESTIMAT DISP: 48 HORES), 2 REGISTRES PER LA REGLA 10');  
   PKG_CONSULTES.SP_SERVEIS_NO_DISP_MES(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   -- ALTA D'UN NOU REGISTRE DE MONITORITZACIO, QUE DONI COM A RESULTAT 'DISPONIBILITAT DEL SERVEI'.
   DBMS_OUTPUT.PUT_LINE('ALTA DUN REGISTRE DE MONITORITZACIO, AMB DISPONIBILITAT DEL SERVEI, PER LA REGLA 10:');  
   PKG_REGISTRE.SP_ALTA_REGISTRE(10, 10, TO_DATE('09/05/2016 00:00:01', 'DD/MM/YYYY HH24:MI:SS'), RSP, V_ID_REGISTRE);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP||', ID REGISTRE CREAT: '||V_ID_REGISTRE);
   PKG_REGISTRE.SP_MODIFICA_REGISTRE(V_ID_REGISTRE, TO_DATE('09/05/2016 00:00:31', 'DD/MM/YYYY HH24:MI:SS'), 20, 'S', NULL, RSP);
 
   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE SERVEIS WEB AMB REGISTRES DE NO DISPONIBILITAT, DESPRES DE REALITZAR LES MODIFICACIONS:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 5 REGISTRES PER LA REGLA 10 (TEMPS ESTIMAT DISP: 72 HORES), 2 REGISTRES PER LA REGLA 10');  
   PKG_CONSULTES.SP_SERVEIS_NO_DISP_MES(P_ANY, P_MES, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R4c] 
-- Consulta que mostra per pantalla el llistat de totes les regles de monitoritzaci que hi 
-- havia actives en aquella data, incloent tamb les dades del servei associat. Tot ordenat 
-- per client. 
--------------------------------------------------------------------------------------------

DECLARE
  P_DATA DATE;
  RSP 	 VARCHAR2(2000);
BEGIN
  P_DATA := to_date('2016-05-03','yyyy-mm-dd');
  
   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE REGLES ACTIVES A UNA DATA:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 9 REGLES ACTIVES');  
   PKG_CONSULTES.SP_REGLES_ACTIVES(P_DATA, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   DBMS_OUTPUT.PUT_LINE('CANVIEM DESTAT LA REGLA 9, A ACTIVADA:');  
   PKG_REGLA.SP_MODIFICA_REGLA(9, TO_DATE('01/05/2016 10:20:30', 'DD/MM/YYYY HH24:MI:SS'), 9, 'REGLA 1 SERVEI WEB 9', 86400, 'A', TO_DATE('02/05/2016 10:30:40', 'DD/MM/YYYY HH24:MI:SS'), RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);   
 
   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE REGLES ACTIVES A UNA DATA:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: 10 REGLES ACTIVES');  
   PKG_CONSULTES.SP_REGLES_ACTIVES(P_DATA, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--------------------------------------------------------------------------------------------
-- ID requisit: [R4d] 
-- Consulta que mostra per pantalla el llistat de tots els serveis web no disponibles en aquest 
-- moment, indicant la regla i el pas en el qual est fallant, i el temps que porta no disponible. 
--------------------------------------------------------------------------------------------

DECLARE
  RSP 	VARCHAR2(2000);
BEGIN
  
   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE SERVEIS WEB NO DISPONIBLES EN AQUEST MOMENT:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: CAP SERVEI WEB EN ESTAT NO DISPONIBLE');  
   PKG_CONSULTES.SP_SERVEIS_NO_DISP(RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   DBMS_OUTPUT.PUT_LINE('CANVIEM DESTAT EL SERVEI WEB 8, A NO DISPONIBLE:');  
   PKG_SERVEI_WEB.SP_MODIFICA_SERVEI_WEB(8, 4, 'DESCRIPCIO SERVEI WEB 8', TO_DATE('01/05/2016 10:20:30', 'DD/MM/YYYY HH24:MI:SS'), 'H', 'https://www.servei_web_8.edu/', 'N', TO_DATE('04/05/2016 00:01:31', 'DD/MM/YYYY HH24:MI:SS'), RSP);
   DBMS_OUTPUT.PUT_LINE('RSP: '||RSP);   

   DBMS_OUTPUT.PUT_LINE('EXECUCI DE LA CONSULTA DE SERVEIS WEB NO DISPONIBLES EN AQUEST MOMENT:');  
   DBMS_OUTPUT.PUT_LINE('RESULTAT ESPERAT: SERVEI WEB 8 EN ESTAT NO DISPONIBLE');  
   PKG_CONSULTES.SP_SERVEIS_NO_DISP(RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
END;
/


spool off;



